/*
								+---------------------------------+
								|                                 |
								|     ***   Rasterizer   ***      |
								|                                 |
								|  Copyright   -tHE SWINe- 2002  |
								|                                 |
								|            Raster.h             |
								|                                 |
								+---------------------------------+
*/

#ifndef __RASTERIZER_INCLUDED
#define __RASTERIZER_INCLUDED

int Init_Engine(int n_New_Width, int n_New_Height);
void Terminate_Engine();

void PreCalc_Multab();

void Switch_Bilerp(int nActivate);

void DrawObject(Matrix *m_object, Matrix *m_camera,
    Object *p_object, Material *p_material, Vector v_light);

Texture *Load_Texture(char *filename);

int Load_Textures(World *world, char *dir);

void Generate_Scanline_Graph();

int Release_Screen(unsigned __int32 *vram);
void Init_Screen();

void Line(Matrix m_projection, Vertex *v_a, Vertex *v_b,
	unsigned __int32 *vram, unsigned __int32 color);

void __fastcall StencilFace(Face *p_face,
	Matrix *m, unsigned __int32 *p_video,
	int b_facing, int b_depth_pass);

void __fastcall Stencil_Invis_Face(Face *p_face, Matrix *m,
	unsigned __int32 *p_video, int b_facing);

#endif